
  ;******************************************************
  ;***                                                ***
  ;***  ASM File generated by ezCircuit Designer     ***
  ;***  Copyright © 2011 eLabtronics                  ***
  ;***  http://www.elabtronics.com/                   ***
  ;***                                                ***
  ;******************************************************

  LIST p=16F819,r=DEC	; Put assembler into PIC16F819 mode.
  ; r=DEC means decimal numbers are
  ; assumed if 'B' or 'h' not specified.

  #include <P16F819.INC>
  __idlocs H'e1ab'

  ;[BOARD:elab16m]


;**************Declare Bit Variables********************

#define		LED_B5		PORTB,5
#define		LED_B4		PORTB,4
#define		SW_A0		PORTA,0
#define		D4		PORTA,3
#define		D5		PORTA,4
#define		D6		PORTB,6
#define		D7_YellowLED 		PORTB,7
#define		EN		PORTA,2
#define		RS		PORTA,1
#define		RW		PORTA,0
#define		Push_Button		PORTA,5
;**************Declare Variables************************
I           equ	  32
J           equ	  33
K           equ	  34


;**************Initialise interrupt subroutine**********

	goto InItSeTuP
	ORG 4

INTERRUPT	
	retfie		;Return From Interrupt


  ;**************Initialise Ports*************************
  InItSeTuP

  __CONFIG  B'11111100011000'

  CLRF PORTA
  CLRF PORTB
  BSF STATUS, RP0
  MOVLW B'10000000'
  MOVWF OPTION_REG
  MOVLW B'00111111'
  MOVWF TRISA
  MOVLW B'00000000'
  MOVWF TRISB
  MOVLW B'01110000'
  MOVWF OSCCON
  BCF STATUS, RP0

;**************Start Of Main Program********************

START				;Start of Main Program
	call	Setup

	call	LED_1Test	;Calls Subroutine: LED_1Test
	call	LED_2Test	;Calls Subroutine: LED_2Test

	goto	$		;End of Main Program

;**************Subroutines******************************

Setup
	;ezCircuit will Initialize all Ports to Digital Port.
	call	DigitalPort	;All Ports Digital
	movlw	100
	call	DELAY	;Start Up Delay

	return
;-------------------------------------------------------

LED_1Test
	bsf	LED_B4		;Set: LED_B4 ON
	movlw	100		;Set W to 100
	call	HundredthDelay	;Calls Subroutine: HundredthDelay
	bcf	LED_B4		;Set: LED_B4 OFF
	movlw	100		;Set W to 100
	call	HundredthDelay	;Calls Subroutine: HundredthDelay
	return
;-------------------------------------------------------

LED_2Test
	bsf	LED_B5		;Set: LED_B5 ON
	movlw	100		;Set W to 100
	call	HundredthDelay	;Calls Subroutine: HundredthDelay
	bcf	LED_B5		;Set: LED_B5 OFF
	movlw	100		;Set W to 100
	call	HundredthDelay	;Calls Subroutine: HundredthDelay
	return
;-------------------------------------------------------

; Turns off analog mode
DigitalPort
	bsf	STATUS,RP0	;Bank 1
	movlw	6	
	movwf	ADCON1	;All pins on PORTA to digital I/O
	bcf	STATUS,RP0	;Bank 0
	return
;-------------------------------------------------------


HundredthDelay
;delays for a set number of centiseconds (100ths)
;W = number of 100ths to delay
	movwf	K	;Assign:K = W
Loop100th				;Label
	movlw	100
	movwf	J	;Assign:J = 100
outerLoop				;Label
	movlw	248
	movwf	I	;Assign:I = 248
innerLoop				;Label
	decfsz	I,F	;Count: I = I - 1, Skip if 0
	goto	innerLoop	;GoTo: innerLoop
	decfsz	J,F	;Count: J = J - 1, Skip if 0
	goto	outerLoop	;GoTo: outerLoop
	decfsz	K,F	;Count: K = K - 1, Skip if 0
	goto	Loop100th	;GoTo: Loop100th
	return				;Return From Subroutine
;-------------------------------------------------------

DELAY
	movwf	J
Dloop		
	decfsz	I,F
	goto	Dloop
	decfsz	J,F
	goto	Dloop
	return		
;-------------------------------------------------------

	END

